// ============================================================================================
// CN[ht@C
// ============================================================================================
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <windows.h>

#include "audioeffectx.h"

//fBCp̏zobt@NX`̃CN[h
#include "CRingBuffer.h"

// ============================================================================================
// ݌v̋L
// ============================================================================================
#define MY_VST_VENDOR       "test vendor"        //(x_[)
#define MY_VST_VERSION      1                    //VSTo[W
#define MY_VST_PRODUCT_NAME "Sample Simple Delay VST"   //VST̐i
#define MY_VST_NAME         "Simple Delay"              //VST̖O

#define MY_VST_INPUT_NUM   2 //͐Bm=1AXeI=2
#define MY_VST_OUTPUT_NUM  2 //o͐Bmo=1AXeIo=2

#define MY_VST_UNIQUE_ID  'SMPL' //j[NID
                                 //Jꍇ͈ȉURLŔsꂽj[NID͂B
                                 //http://ygrabit.steinberg.de/~ygrabit/public_html/index.html

#define MY_VST_PRESET_NUM    1 //vZbgvO̐
#define MY_VST_PARAMETER_NUM 2 //p[^̐

//VST̃p[^`ĂB
//0̘AԂłȂ΂ȂȂB
#define DELAY_LEVEL  0
#define DELAY_TIME     1

// ============================================================================================
// VST̊{ƂȂNX
// ============================================================================================
class MyDelayVST : public AudioEffectX
{
protected:
	CRingBuffer RingBufL;
	CRingBuffer RingBufR;

	float fDlayLevel;
	float fDelayTime;

public:
	MyDelayVST (audioMasterCallback audioMaster);
	~MyDelayVST ();

	//(x_[)Ao[WAiAVST̖O
	//HostAvP[V֒m点郁o[֐
	virtual bool getVendorString (char* text);
	virtual VstInt32 getVendorVersion ();
	virtual bool getProductString (char* text);
	virtual bool getEffectName (char* name);

	// GtFN^[̃p[^Ɋւ郁o[֐
	virtual void  setParameter (VstInt32 index, float value);
	virtual float getParameter (VstInt32 index);
	virtual void  getParameterName (VstInt32 index, char* text);
	virtual void  getParameterLabel (VstInt32 index, char* label);
	virtual void  getParameterDisplay (VstInt32 index, char* text);

	// M郁o[֐
	virtual void processReplacing (float** inputs, float** outputs, VstInt32 sampleFrames);
};

// ============================================================================================
// VST̂𐶐邽߂̊֐
// ============================================================================================
AudioEffect* createEffectInstance (audioMasterCallback audioMaster)
{
	//newłVST𐶐|C^Ԃ
	return new MyDelayVST (audioMaster);
}

// ============================================================================================
// RXgN^AfXgN^(VST̏AILq)
// ============================================================================================
MyDelayVST::MyDelayVST (audioMasterCallback audioMaster)
: AudioEffectX (audioMaster, MY_VST_PRESET_NUM, MY_VST_PARAMETER_NUM)
{
	//VST̏sB

	//ȉ̊֐Ăяoē͐Ao͐̏ݒ肷B
	//KĂяoȂ΂ȂȂB
	setNumInputs (MY_VST_INPUT_NUM);    //͐̐ݒ
	setNumOutputs (MY_VST_OUTPUT_NUM);  //o͐̐ݒ
	setUniqueID (MY_VST_UNIQUE_ID);     //j[NID̐ݒ

	isSynth (false);          //VSTSynthǂ̃tOݒB
	                         //Synth̏ꍇctrueAEffectoȑꍇcfalse

	canProcessReplacing ();  //VST\ǂ̃tOݒB
	                         //sȂVST͂Ȃ̂ŕK̊֐ĂяoB

	//VST̃p[^B
	fDlayLevel = 0.4f;
	fDelayTime = 100.0f;

	RingBufL.SetInterval((int)(fDelayTime / 1000.0f * getSampleRate() ));
	RingBufR.SetInterval((int)(fDelayTime / 1000.0f * getSampleRate() ));
}

MyDelayVST::~MyDelayVST ()
{
	//VST̏IB
	//VSTł͓Ɏs鏈͂ȂB
}

// ============================================================================================
// (x_[)Ao[WAiAVST̖OHostAvP[V֒m点郁o[֐
// ============================================================================================
bool MyDelayVST::getVendorString (char* text)
{
	//(x_[)textɊi[trueԂB
	//kVstMaxVendorStrLeńuvstsdk2.4\pluginterfaces\vst2.x\aeffect.hv
	//`ĂB(kVstMaxVendorStrLen = 64)
	vst_strncpy (text, MY_VST_VENDOR, kVstMaxVendorStrLen);
	return true;
}

VstInt32 MyDelayVST::getVendorVersion ()
{
	//o[W()ԂB
	return MY_VST_VERSION;
}

bool MyDelayVST::getProductString (char* text)
{
	//itextɊi[trueԂB
	//kVstMaxProductStrLeńuvstsdk2.4\pluginterfaces\vst2.x\aeffect.hv
	//`ĂB(kVstMaxProductStrLen = 64)
	vst_strncpy (text, MY_VST_PRODUCT_NAME, kVstMaxProductStrLen);
	return true;
}

bool MyDelayVST::getEffectName (char* name)
{
	//inameɊi[trueԂB
	//kVstMaxEffectNameLeńuvstsdk2.4\pluginterfaces\vst2.x\aeffect.hv
	//`ĂB(kVstMaxEffectNameLen = 32)
	vst_strncpy (name, MY_VST_NAME, kVstMaxEffectNameLen);
	return true;
}

// ============================================================================================
// GtFN^[̃p[^[̐ݒA\so[֐
// ============================================================================================
void  MyDelayVST::setParameter (VstInt32 index, float value)
{
	//indexŎw肳ꂽp[^ɒlݒ肷B
	//value0.0f`1.0fŗ^B
	switch (index)
	{
	case DELAY_LEVEL:
		fDlayLevel = value;
		break;
	case DELAY_TIME:
		fDelayTime = 900.0f * value + 100.0f; //100~b`1000~b
		RingBufL.SetInterval((int)(fDelayTime / 1000.0f * getSampleRate() ));
		RingBufR.SetInterval((int)(fDelayTime / 1000.0f * getSampleRate() ));
		break;
	}
}

float MyDelayVST::getParameter (VstInt32 index)
{
	//indexŎw肳ꂽp[^̒l
	//0.0f`1.0f͈̔͂ŕԂ
	float value = 0.0f;
	switch (index)
	{
	case DELAY_LEVEL:
		value = fDlayLevel;
		break;
	case DELAY_TIME:
		value = (fDelayTime - 100.0f) / 900.0f; //100~b`1000~b0.0f`1.0f͈̔͂ɂ
		break;
	}
	return value;
}

void  MyDelayVST::getParameterName (VstInt32 index, char* text)
{
	//indexŎw肳ꂽp[^̖OtextɊi[
	//kVstMaxParamStrLeńuvstsdk2.4\pluginterfaces\vst2.x\aeffect.hv
	//`ĂB(kVstMaxParamStrLen = 8)
	switch (index)
	{
	case DELAY_LEVEL:
		vst_strncpy (text, "level", kVstMaxParamStrLen);
		break;
	case DELAY_TIME:
		vst_strncpy (text, "time", kVstMaxParamStrLen);
		break;
	}
}

void  MyDelayVST::getParameterLabel (VstInt32 index, char* label)
{
	//indexŎw肳ꂽp[^̒PʂlabelɊi[
	//kVstMaxParamStrLeńuvstsdk2.4\pluginterfaces\vst2.x\aeffect.hv
	//`ĂB(kVstMaxParamStrLen = 8)
	switch (index)
	{
	case DELAY_LEVEL:
		vst_strncpy (label, "%", kVstMaxParamStrLen);
		break;
	case DELAY_TIME:
		vst_strncpy (label, "m sec", kVstMaxParamStrLen);
		break;
	}
}

void  MyDelayVST::getParameterDisplay (VstInt32 index, char* text)
{
	//indexŎw肳ꂽp[^̕\etextɊi[
	//kVstMaxParamStrLeńuvstsdk2.4\pluginterfaces\vst2.x\aeffect.hv
	//`ĂB(kVstMaxParamStrLen = 8)
	switch (index)
	{
	case DELAY_LEVEL:
		float2string (fDlayLevel * 100.0f, text, kVstMaxParamStrLen);
		break;
	case DELAY_TIME:
		float2string (fDelayTime, text, kVstMaxParamStrLen);
		break;
	}
}

// ============================================================================================
// M郁o[֐
// ============================================================================================
void MyDelayVST::processReplacing (float** inputs, float** outputs, VstInt32 sampleFrames)
{
	//́Ao͂2zœnB
	//͂-1.0f`1.0f̊ԂœnB
	//o͂-1.0f`1.0f̊ԂŏޕKvB
	//sampleFramesobt@̃TCY
	float* inL  =  inputs[0]; // p
	float* inR  =  inputs[1]; // Ep
	float* outL = outputs[0]; //o p
	float* outR = outputs[1]; //o Ep

	while (sampleFrames > 0)
	{
		//ŉsB

		//͐MOobt@
		RingBufL.SetValue((*inL));
		RingBufR.SetValue((*inR));

		//Oobt@olƓ͐MZ
		(*outL) = (*inL) + fDlayLevel * RingBufL.GetValue();
		(*outR) = (*inR) + fDlayLevel * RingBufR.GetValue();

		//Oobt@̓ǂݎʒuA݈ʒui߂
		RingBufR.ForwardReadPosition();
		RingBufL.ForwardReadPosition();

		RingBufR.ForwardWritePosition();
		RingBufL.ForwardWritePosition();


		inL++;
		inR++;
		outL++;
		outR++;
		sampleFrames--;
	}

}

